Subject: [PATCH v4 09/21] KVM: arm/arm64: mask/unmask daif around VHE guests

From: [email-masked] (Christoffer Dall)
Date: Fri, 3 Nov 2017 13:45:02 +0100

On Thu, Nov 02, 2017 at 12:14:28PM +0000, James Morse wrote:
> Hi Christoffer,
> 
> On 30/10/17 07:40, Christoffer Dall wrote:
> > On Thu, Oct 19, 2017 at 03:57:55PM +0100, James Morse wrote:
> >> Non-VHE systems take an exception to EL2 in order to world-switch into the
> >> guest. When returning from the guest KVM implicitly restores the DAIF
> >> flags when it returns to the kernel at EL1.
> >>
> >> With VHE none of this exception-level jumping happens, so KVMs
> >> world-switch code is exposed to the host kernel's DAIF values, and KVM
> >> spills the guest-exit DAIF values back into the host kernel.
> >> On entry to a guest we have Debug and SError exceptions unmasked, KVM
> >> has switched VBAR but isn't prepared to handle these. On guest exit
> >> Debug exceptions are left disabled once we return to the host and will
> >> stay this way until we enter user space.
> >>
> >> Add a helper to mask/unmask DAIF around VHE guests. The unmask can only
> >> happen after the hosts VBAR value has been synchronised by the isb in
> >> __vhe_hyp_call (via kvm_call_hyp()). Masking could be as late as
> >> setting KVMs VBAR value, but is kept here for symmetry.
> 
> > Reviewed-by: Christoffer Dall <[email-masked]>
> 
> Thanks!
> 
> 
> >> ---
> >> Give me a kick if you want this reworked as a fix (which will then
> >> conflict with this series), or a backportable version.
> > 
> > I don't know of any real-world issues where some more graceful handling
> > of SErrors would make sense on older kernels, so I'm fine with just
> > merging this together with this series.
> 
> What about debug?

Are we unmasking debug exceptions as we should with this patch?

If so, I suppose that could be required for something like kgdb or when
running KVM as a guest hypervisor (nested).

In that case, we should probably provide a backport for stable, if we
think people are going to be running older kernels on VHE systems, which
they probably are.

> > On guest exit Debug exceptions are left disabled once we return to the host
> > and will stay this way until we enter user space.

[The indentation seems to indicate I wrote this, but I don't think I
did.  I'm confused.]

> 
> Today VHE:KVM causes the kernel to run with SError unmasked and debug disabled
> until the next return to user-space, whereas previously the kernel expected
> SError to be masked and debug enabled.
> 
> 
> (Reposting just the SError rework without this patch changes the kernel to
> expect SError to be unmasked, which isn't making this any worse.)
> 
I'm sorry, I don't understand this discussion.  What is today, and what
is previously, and are you suggesting we drop this patch, or that the
rest of this series is somehow going to be applied without this patch?

Reset: I think this patch is fine in the context of this series..  I now
have no idea what we need to do in terms of older kernels.

Thanks,
-Christoffer